package gregapi.block.multitileentity;

import gregapi.GT_API;
import gregapi.block.IBlockPlacable;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_RegisterIcons;
import gregapi.render.IRenderedBlock;
import gregapi.render.IRenderedBlockObject;
import gregapi.render.ITexture;
import gregapi.render.RendererBlockTextured;
import gregapi.util.UT;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.StatCollector;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.client.MinecraftForgeClient;
import cpw.mods.fml.common.registry.GameRegistry;

/**
 * @author Gregorius Techneticies
 */
public class MultiTileEntityBlockInternal extends Block implements IRenderedBlock, IBlockPlacable {
	public final MultiTileEntityRegistry mMultiTileEntityRegistry;
	
	public MultiTileEntityBlockInternal(MultiTileEntityRegistry aMultiTileEntityRegistry) {
		super(Material.anvil);
		mMultiTileEntityRegistry = aMultiTileEntityRegistry;
		GameRegistry.registerBlock(this, MultiTileEntityItemInternal.class, mMultiTileEntityRegistry.mNameInternal);
		if (GT_API.api_proxy.isClientSide()) MinecraftForgeClient.registerItemRenderer(Item.getItemFromBlock(this), RendererBlockTextured.INSTANCE);
	}
	
	@Override public ITexture getTexture(int aRenderPass, byte aSide, ItemStack aStack) {return null;}
	@Override public ITexture getTexture(int aRenderPass, byte aSide, IBlockAccess aWorld, int aX, int aY, int aZ) {return null;}
	@Override public boolean setBlockBounds(int aRenderPass, ItemStack aStack) {return false;}
	@Override public boolean setBlockBounds(int aRenderPass, IBlockAccess aWorld, int aX, int aY, int aZ) {return false;}
	@Override public int getRenderPasses(ItemStack aStack) {return 0;}
	@Override public int getRenderPasses(IBlockAccess aWorld, int aX, int aY, int aZ) {return 0;}
	
	@Override
	public IRenderedBlockObject passRenderingToObject(IBlockAccess aWorld, int aX, int aY, int aZ) {
		return null;
	}
	
	@Override
	public IRenderedBlockObject passRenderingToObject(ItemStack aStack) {
		TileEntity tTileEntity = mMultiTileEntityRegistry.getNewTileEntity(aStack);
		return tTileEntity instanceof IRenderedBlockObject ? (IRenderedBlockObject)tTileEntity : null;
	}
	
	@Override
	public void registerBlockIcons(IIconRegister aIconRegister) {
		for (MultiTileEntityClassContainer tClassContainer : mMultiTileEntityRegistry.mRegistry.values()) if (tClassContainer.mCanonicalTileEntity instanceof IMTE_RegisterIcons) ((IMTE_RegisterIcons)tClassContainer.mCanonicalTileEntity).registerIcons(aIconRegister);
	}
	
    @Override public final int getRenderBlockPass() {return ITexture.Util.MC_ALPHA_BLENDING?1:0;}
	@Override public final int getRenderType() {return RendererBlockTextured.INSTANCE==null?super.getRenderType():RendererBlockTextured.INSTANCE.mRenderID;}
	@Override public final String getUnlocalizedName() {return mMultiTileEntityRegistry.mNameInternal;}
	@Override public final String getLocalizedName() {return StatCollector.translateToLocal(mMultiTileEntityRegistry.mNameInternal + ".name");}
	
	@Override
	public boolean placeBlock(World aWorld, int aX, int aY, int aZ, byte aSide, short aMetaData, NBTTagCompound aNBT, boolean aCauseBlockUpdates, boolean aForcePlacement) {
    	Block tReplacedBlock = aWorld.getBlock(aX, aY, aZ);
        MultiTileEntityContainer tContainer = mMultiTileEntityRegistry.getNewTileEntityContainer(aMetaData, aNBT);
        if (tContainer != null && aWorld.setBlock(aX, aY, aZ, tContainer.mBlock, 15-tContainer.mBlockMetaData, 2)) {
            UT.Worlds.setTileEntity(aWorld, aX, aY, aZ, tContainer.mTileEntity, false);
            ((IMultiTileEntity)tContainer.mTileEntity).setShouldRefresh(false);
            aWorld.setBlock(aX, aY, aZ, tContainer.mBlock, tContainer.mBlockMetaData, 0);
            ((IMultiTileEntity)tContainer.mTileEntity).setShouldRefresh(true);
            UT.Worlds.setTileEntity(aWorld, aX, aY, aZ, tContainer.mTileEntity, aCauseBlockUpdates);
            if (!aWorld.isRemote && aCauseBlockUpdates) {
            	aWorld.notifyBlockChange(aX, aY, aZ, tReplacedBlock);
                aWorld.func_147453_f(aX, aY, aZ, tContainer.mBlock);
            }
            aWorld.func_147451_t(aX, aY, aZ);
        	return true;
        }
		return false;
	}
}